package roma;
/** 
 * Classe Node:
 *
 * Classe usata per descrivere il singolo nodo di un albero binario.
 * E` possibile creare nodi con riferimenti nulli al father e/o a
 * to the children in base al numero di argomenti del
 * costruttore.  
 */
public class Node {
    public Object  value;    // Campo value
    public Node    left;     // Riferimento al figlio left
    public Node    right;    // Riferimento al figlio right
    public Node    parent;   // Riferimento to the father
    
   /*
      Costruttore di un Node in cui l'oggetto v (diverso da null)
       il campo value, i parametri l e r sono riferimenti al figlio
      left e right, rispettivamente, e il parametro f  il
      riferimento to the father.
   */
   public Node( Object v, Node l, Node r, Node f ) {
      if ( v == null )
         throw new IllegalArgumentException( );
      value  = v;
      left   = l;
      right  = r;
      parent = f;
   // Aggiorna il campo padre del figlio sinistro (se esiste)
   if (l != null) 
       l.parent = this;
   // Aggiorna il campo padre del figlio destro   (se esiste)
   if (r != null) 
       r.parent = this;
    }

   // Varianti del costruttore suddetto
   public Node( Object v ) {                 // leaf
      this (v, null, null, null);
   }

   public Node( Object v, Node l ) {         // unary node
      this (v, l, null, null);
   }
    
   public Node( Object v, Node l, Node r ) { // binary node
      this (v, l, r, null);
   }
        
}
