package roma;
import  java.util.Vector;

/**
 * Classe Stack:
 *
 * Realizzazione dello stack mediante Vector, utilizzando la specifica
 * di Java Collections API disponibile in <code>java.util.*</code>.
 */

public class Stack {
    
   Vector stack;

    /**
     * Costruttore dello stack.
     */
   public Stack( ) {
      stack = new Vector( );
   }

    /**
     * Inserisce un oggetto in cima allo stack.
     * @param x  l'oggetto da inserire.
     * @return   l'oggetto inserito.
     * @exception IllegalArgumentException se l'argomento passato
     *            &egrave; <code>null</code>.  
     */
   public Object push( Object x ) {
      if ( x == null )
         throw new IllegalArgumentException( );
         stack.addElement( x );
         return x;
   }
    
    /**
     * Rimuove e restituisce l'oggetto in cima allo stack.
     * @return   l'oggetto in cima.
     * @exception EmptyStackException con stack vuoto.
     */
   public Object pop( ) {
      if ( isEmpty( ) )
         throw new EmptyStackException( );
      return stack.remove( stack.size( )-1 );
   }

    /**
     * Restituisce l'oggetto in cima allo stack senza estrarlo.
     * @return   l'oggetto in cima.
     * @exception EmptyStackException con stack vuoto.
     */
   public Object peek( ) {
      if ( isEmpty( ) )
         throw new EmptyStackException( );
      return stack.lastElement( );
   }

    /**
     * Verifica se lo stack &egrave; vuoto.
     * @return  <code>true</code> se lo stack &egrave; vuoto;
     *          <code>false</code> altrimenti.
     */
   public boolean isEmpty( ) {
      return stack.isEmpty( );
   }
    
    /**
     *  Svuota lo stack.
     */
   public void empty( ) {
      stack.clear( );
   }

}