/*
 * DepthFirstVisitGUI.java
 * Created on 21 dicembre 2003
 */

package treeparser;

import java.io.IOException;
import javax.swing.JFrame;
import roma.Node;

/**
 * @author Corrado and Alberto (9.2.2004)
 */
public class DepthFirstVisitGUI extends JFrame {
    
    /** Creates new form DepthFirstVisitGUI */
    public DepthFirstVisitGUI() {
        initComponents();
    }
    
    /** This method is called from within the constructor to
     *  initialize the form.
     *  WARNING: Do NOT modify this code. The content of this method is
     *  always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        txInput = new javax.swing.JTextField();
        txOutTree = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        txOutDPF = new javax.swing.JTextField();
        btParse = new javax.swing.JButton();
        menuBar = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        // openMenuItem = new javax.swing.JMenuItem();
        // saveMenuItem = new javax.swing.JMenuItem();
        // saveAsMenuItem = new javax.swing.JMenuItem();
        exitMenuItem = new javax.swing.JMenuItem();
        // helpMenu = new javax.swing.JMenu();
        // contentsMenuItem = new javax.swing.JMenuItem();
        // aboutMenuItem = new javax.swing.JMenuItem();

        getContentPane().setLayout(null);

        setTitle("Depth First Visit");
        setFont(new java.awt.Font("Default", 0, 10));
        setLocationRelativeTo(null);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jLabel1.setBackground(new java.awt.Color(204, 204, 0));
        jLabel1.setFont(new java.awt.Font("Default", 0, 10));
        jLabel1.setText("<HTML>\n<PRE>\n"
        +" Grammar for the input tree:  char ::= '0' | '1' | ... | '9'\n"
        +"                tree ::= char | - char tree | "
        +" (tree char tree)\n"
        +" Internal tree: tree = Num  |  Num x tree  | tree x Num x tree\n"
        +"                      (Leaf)     (Unary)          (Binary)\n"
        +" Grammar for the output tree:\n"
        +"                tree ::= n | (n.tree) | (tree.n.tree)\n"
        +"<PRE>\n</HTML>");

        jLabel1.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        jLabel1.setOpaque(true);
        getContentPane().add(jLabel1);
        jLabel1.setBounds(5, 5, 500, 85);

        jLabel2.setText("Input Tree:");
        getContentPane().add(jLabel2);
        jLabel2.setBounds(10, 100, 90, 16);

        jLabel3.setText("Output Tree:");
        getContentPane().add(jLabel3);
        jLabel3.setBounds(10, 140, 90, 16);

        getContentPane().add(txInput);
        txInput.setBounds(120, 100, 310, 20);

        txOutTree.setBackground(new java.awt.Color(204, 255, 204));
        getContentPane().add(txOutTree);
        txOutTree.setBounds(120, 140, 310, 20);

        btParse.setText("Parse");
        btParse.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btParseActionPerformed(evt);
            }
        });

        getContentPane().add(btParse);
        btParse.setBounds(160, 220, 68, 26);

        jLabel4.setText("Depth First Visit:");
        getContentPane().add(jLabel4);
        jLabel4.setBounds(10, 180, 140, 16);

        txOutDPF.setBackground(new java.awt.Color(102, 255, 102));
        getContentPane().add(txOutDPF);
        txOutDPF.setBounds(120, 180, 310, 20);

        fileMenu.setText("File");
        // openMenuItem.setText("Open");
        // fileMenu.add(openMenuItem);

        // saveMenuItem.setText("Save");
        // fileMenu.add(saveMenuItem);

        // saveAsMenuItem.setText("Save As ...");
        // fileMenu.add(saveAsMenuItem);

        exitMenuItem.setText("Exit");
        exitMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(exitMenuItem);

        menuBar.add(fileMenu);

        // helpMenu.setText("Help");
        // contentsMenuItem.setText("Contents");
        // helpMenu.add(contentsMenuItem);

        // aboutMenuItem.setText("About");
        // helpMenu.add(aboutMenuItem);

        // menuBar.add(helpMenu);

        setJMenuBar(menuBar);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-437)/2, (screenSize.height-300)/2, 437, 300);
    }//GEN-END:initComponents

    private void btParseActionPerformed(java.awt.event.ActionEvent evt) {
        //GEN-FIRST:event_btParseActionPerformed
        // Add your handling code here:
		Node tree = null;
		try {
			tree = DepthFirstVisit.parseTree(txInput.getText());
		} catch (IOException e) {
			e.printStackTrace();
            txOutTree.setText("IOEXCEPTION");
        } catch ( ParseTreeException pex){
            txOutTree.setText(pex.getMessage());
        }
		if (tree != null){
            txOutTree.setText(tree.toString());
            txOutDPF.setText(DepthFirstVisit.depthFirstVisit(tree));
		}
        
    }//GEN-LAST:event_btParseActionPerformed
    
    private void exitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {
     //GEN-FIRST:event_exitMenuItemActionPerformed
        System.exit(0);
    }//GEN-LAST:event_exitMenuItemActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {
     //GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new DepthFirstVisitGUI().show();
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // private javax.swing.JMenuItem aboutMenuItem;
    // private javax.swing.JMenuItem contentsMenuItem;
    private javax.swing.JMenuItem exitMenuItem;
    private javax.swing.JMenu fileMenu;
    // private javax.swing.JMenu helpMenu;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JMenuBar menuBar;
    // private javax.swing.JMenuItem openMenuItem;
    // private javax.swing.JMenuItem saveAsMenuItem;
    // private javax.swing.JMenuItem saveMenuItem;
    private javax.swing.JTextField txInput;
    private javax.swing.JTextField txOutTree;
    private javax.swing.JTextField txOutDPF;
    private javax.swing.JButton btParse;
    // End of variables declaration//GEN-END:variables
    
}