/*
 */
package treeparser;

import roma.Stack;
import roma.Node;

/**
 * Questa classe rappresenta uno stack che
 * contiene elementi di tipo Node,
 *  realizzata sulla base della classe Stack di Pisa
 */

public class TreeStack {
	
   Stack stack;
	
   public TreeStack(){
      stack = new Stack();
   }
	
   /**
     *
     * @param node nodo radice dell'albero da inserire nello stack
     * @return l'albero appena inserito nello stack
   */
   public Node push(Node node){
      return (Node)stack.push(node);
   }

   /**
     *
     * @return l'albero alla cima allo stack, e lo estrae
   */
   public Node pop(){
      return (Node)stack.pop();
   }

   /**
     *
     * @return l'albero presente in cima allo stack, e non lo estrae
   */
   public Node top(){
      return (Node)stack.peek();
   }

   /**
     *
     * @return true se lo stack  vuoto
   */
   public boolean isEmpty(){
      return stack.isEmpty();
   }	
}
